 #include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <stdio.h>

#define BASE 65536
								//base of calculation

struct bignum {
	int sign;			//0- pos 1-neg
	int nalloc;
	int top;
	unsigned short *val;
};

//create new number
struct bignum *bnum_new ()						
{
	struct bignum *newnum;
	newnum = malloc ( sizeof ( struct bignum));
	
	if ( newnum == NULL) {
		fprintf ( stderr, "malloc: %s\n", strerror(errno));
		return 0;
	}		
	memset ( newnum, 0, sizeof ( struct bignum));
	return newnum;
}

//free memory
int bnum_free ( struct bignum *a)
{
	free ( a);
	return 0;
}

//сбрасывает значение 
int bnum_unset ( struct bignum *a)
{
	int i = a->top;
	for ( i; i >= 0; i--)										//////
		a->val[i] = 0;
	a->sign = 0;
	a->top = 0;
	return 0;
}

//освобождает память в val
int bnum_reset ( struct bignum *a)
{
	free ( a->val);
	a->top = 0;
	a->sign = 0;
	a->nalloc = 0;
	a->val = 0;
	return 0;
}

/*bignum_abs_cmp compare a,b and return:
1 if |a| > |b|
0 if |a| == |b|
-1 if |a| < |b|
*/
int bnum_abs_cmp ( struct bignum *a, struct bignum *b)
{
	int i;
	if ( a->top == b->top) {		
		for ( i = a->top; i >= 0; i--) {
			if ( a->val[i] == b->val[i])
				continue;
			if ( a->val[i] > b->val[i])
				return 1;
			else
				return -1;
		}
	}
	else if ( a->top > b->top)
		return 1;
	else 
		return -1;
}


//print_number in 65536-base
int bnum_print ( struct bignum *a)
{
	int i = a->top;
	if ( a->sign == 1)
		printf ( "-");
	for ( i; i >= 0; i--) {
		printf ( "%d", a->val[i]);
		if ( i != 0)
			printf ( ".");
	}
	printf("\n");
	return 0;
}

int bnum_set ( struct bignum *a, int sign,int nalloc, unsigned short *val)
{
	int top=0,i=0;
	if (sign == 1 || sign == 0)
		a->sign = sign;
	else 
		return 0;
	if ( nalloc > 0)
		a->nalloc = nalloc;
	
	a->val = realloc ( a->val, nalloc);
	
	for ( i = nalloc - 1; i >= 0; i--) {	
		a->val[i] = val[i];
		if ( top == 0 && a->val[i] !=0)
			top = i;
	}
	a->top = top;
	
	return 0;
}

